
//----Cabeceras ---
// biblioteca estndar
#include <iostream>  
#include <iomanip>
#include <string>
// control de errores
#include <error.h>
// utilidades matemticas
#include <matutil.h>
// Declaraciones funcin a explorar
#include <func.h>
// algoritmos de races
#include <raices.h>

// Espacio de nombres estndar
using namespace std;

// Escribe una tabla de valores
void escribe_tabla(double a, double b, double raiz, int iter){
  cout << iter << "\t" 
       << setw(12) << setprecision(8) << 
    a << "\t  " 
       << setw(12) << setprecision(8) << 
    raiz << "\t  " 
       << setw(12) << setprecision(8) << 
    b  << endl; 
}

//Escribe parmetros por la pantalla

void escribe_parametros(double a,double b,double tol, int maxiter, int metodo)
{
  cout << "Intervalo = ["<<a<<","<<b<<"]"<<endl;
  cout << "Tolerancia = "<<tol<<endl;
  cout << "max iter = "<<maxiter<<endl;
  cout << "mtodo = "<<endl;
  if (metodo==1) cout << "biseccin" <<endl;
  else if (metodo==2) cout << "regula falsi" <<endl;
  else if (metodo==3) cout << "newton rapson" <<endl;
}


/* Programa principal:
 * - Inicializa
 * - Calcula la tolerancia
 * - Busca la raiz por el metodo elegido por el usuario
 */
int main () 
{      
  //Inicializacin 
  //Extremos del intervalo
  double a = 0;
  double b = 3;

  cout << "Introduzca extremos del intervalo [a,b]" << endl;
  cout << "a? "; cin>>a;
  cout << "b? "; cin>>b;

  // Devuelve CEINVAL si a > b
  if( a > b ) 	    
    return CEINVAL;

  // Precisin relativa
  double epsrel = 0.01;

  cout << "Precisin relativa? "; cin>>epsrel;

  // Mximo nmero de iteraciones
  int maxiter = 100;
  cout << "Mximo nmero de iteraciones ?  "; cin >> maxiter ;

  // Mtodo (1 = biseccin, 2 = rfalsi, 3 = newton)
  int metodo = 1;

  cout << "Introduzca mtodo (1 = biseccin, 2 = rfalsi, 3 = newton)"
       <<endl;
  cout <<"Metodo? "; cin >>metodo;

  //Calcula la tolerancia

  if (epsrel < 0.0)
      error ("La precisin relativa requerida es negativa", CEMALTOL);
  double tol = epsrel* maximo ( fabs(b-a), fabs(a+b)/2);

  escribe_parametros(a,b,tol, maxiter, metodo);


  // Busca races
  double raiz,f_raiz,df_raiz;

  // Segn el valor de metodo utiliza uno u otro algoritmo
  // Metodo de biseccion  
  if(metodo == 1){
    int status;
    //Inicializa el metodo
    status = bisecIni (fun, a, b);
    if (status != EXITO) error("error en bisecIni",status);

    //Iteraciones
    status = ITERANDO;
    int iter = 0;
    while (status == ITERANDO){
      iter++;

      status = bisecIter (fun, a, b, raiz);

      if (status == EXITO)
      //El mtodo da con la raz exacta 
        cout << "El mtodo converge exactamente" << endl;
      else if (status != ITERANDO)
        error("error en la iteracin", status);
      //Test de convergencia 
      else if (fabs(a-b) < tol){
	status = EXITO;
        cout << " El mtodo ha convergido por debajo de la tolerancia" << endl;
      }

      // Escribe resultados
      escribe_tabla(a,b,raiz,iter);

      if (iter >= maxiter ) 
        error("excede nmero mximo de iteraciones", CEMAXITER);

    }

    cout << " La raz es "
       << setw(12) << setprecision(8) 
       << raiz << endl; 
    cout << " Nmero de iteraciones empleado "
       << iter << endl; 

  }
  
  //Metodo de regula falsi 
  else if(metodo == 2){
    int status;
    //Inicializa el metodo
    status = rfalsiIni (fun, a, b);
    if (status != EXITO) error("error en rfalsiIni",status);

    //Iteraciones
    status = ITERANDO;
    int iter = 0;
    double raiz_previa = a;
    while (status == ITERANDO){
      iter++;

      status = rfalsiIter (fun, a, b, raiz);
      if (status == EXITO){
        //El mtodo da con la raz exacta 
        cout << "El mtodo converge exactamente" << endl;
      }
      else if (status != ITERANDO)
        error("error en la iteracin", status);
      //Test de convergencia 
      else if (fabs(raiz-raiz_previa) < tol){
	status = EXITO;
        cout << " El mtodo ha convergido por debajo de la tolerancia" << endl;
      }

      // Escribe resultados
      escribe_tabla(a,b,raiz,iter);

      if (iter >= maxiter ) 
        error("excede nmero mximo de iteraciones", CEMAXITER);

      raiz_previa = raiz;

    }

    cout << " La raz es "
       << setw(12) << setprecision(8) 
       << raiz << endl; 
    cout << " Nmero de iteraciones empleado "
       << iter << endl; 

  }

  //Metodo de Newton-Raphson  
  else if(metodo == 3){
    int status;
    // Inicializa el mtodo con la aproximacin inicial al extremo inferior 
    // del intervalo
    raiz = a;
    status = newtonIni (fun, Dfun, f_raiz, df_raiz, raiz);
    if (status != EXITO) error("error en newtonIni",status);

    //Iteraciones
    status = ITERANDO;
    int iter = 0;
    double raiz_previa = raiz;
    while (status == ITERANDO){
      iter++;

      status = newtonIter (fun, Dfun, f_raiz, df_raiz, raiz);
      if (status != ITERANDO)
        error("error en la iteracin", status);
      //Test de convergencia 
      else if (fabs(raiz-raiz_previa) < tol){
	status = EXITO;
        cout << " El mtodo ha convergido por debajo de la tolerancia" << endl;
      }

      // Escribe resultados
      escribe_tabla(a,b,raiz,iter);

      if (iter >= maxiter ) 
        error("excede nmero mximo de iteraciones", CEMAXITER);

      raiz_previa = raiz;

    }

    cout << " La raz es "
       << setw(12) << setprecision(8) 
       << raiz << endl; 
    cout << " Nmero de iteraciones empleado "
       << iter << endl; 

  }

  else 
      cout <<"Escribe 1, 2 o 3" << endl; 

  
  return 0;
    

}








































